#ifndef CHierScatter_H
#define CHierScatter_H

#include <xmdv/CHierDisplay.h>
#include <xmdv/CScatter.h>
#include <xmdv/Vec2.h>

class CHierScatter: public CHierDisplay, public CScatter 
{
protected: 
    ARR<Vec2> p;
	int dimx, dimy;

public:
	CHierScatter(CHierDisplayInformation* hier_info);

protected:
	bool TestDimensionality();
	//draw a single cluster;
	void DrawSingleCluster(Cluster &c, bool brushed);
	//set canvas background, clear canvas, and draw axes;
	void PrepareCanvas();
	//set parameters used for drawing;
	void SetParameters();
	//free space used for drawing;
	void FreeSpace();

    void DrawSingleNodeBand(Cluster &c, double density, bool brushed);

    void InputMouseMotion(int x, int y);
	void InputButtonPress(int button, int x, int y);
	void InputButtonRelease(int button, int x, int y);

};

#endif



