#include <xmdv/CScatter.h>
#include <xmdv/XmdvTool.h>
#include <xmdv/ogl.h>

CScatter::CScatter()
{
}


CScatter::~CScatter()
{
}


bool CScatter::ScatterTestDimensionality()
{
	if ( dataset->dims < 1 )
		return false;
	else 
		return true;
}


// Draw grid.
void CScatter::DrawScatterGrid(grCanvas *canvas)
{
    glLineWidth(1.);
    glShadeModel(GL_SMOOTH);
    canvas->SetForeground(interface_color[GRID1]);
    canvas->SetXorMode(false);

    int i;
    for (i = 0;i < dataset->dims;i++)
        for (int j = 0;j < dataset->dims;j++)
            canvas->DrawRectangle2(screen_distortion->scatter_X_axes[i], screen_distortion->scatter_X_axes[i+1], 
                                   screen_distortion->scatter_Y_axes[j], screen_distortion->scatter_Y_axes[j+1] );
/* for fisheye view
	int i;
	for ( i = 0; i <= dataset->dims; i++ )
		canvas->DrawLineTemp(screen_distortion->scatter_X_axes[i], screen_distortion->scatter_Y_axes[0],
								screen_distortion->scatter_X_axes[i], screen_distortion->scatter_Y_axes[dataset->dims]);
	for ( i = 0; i <= dataset->dims; i++ )
		canvas->DrawLineTemp(screen_distortion->scatter_X_axes[0], screen_distortion->scatter_Y_axes[i],
								screen_distortion->scatter_X_axes[dataset->dims], screen_distortion->scatter_Y_axes[i]);
*/

//jing draw the labels of the plots
    // do labels
    canvas->SetForeground(interface_color[TEXT]);

    Vec2 font_size = canvas->GetDataFontSize("W");

    // draw horizontal labels
    // add letters one at a time until space runs out
    for (i=0; i<dataset->dims; i++)
    {
        double y = .8*font_size.Y;
        canvas->DrawConfinedString(screen_distortion->scatter_X_axes[i],y,dataset->names[i],
								   screen_distortion->scatter_X_interval[i]-font_size.X*3);
    }

    // draw vertical labels
    // add letters one at a time until space runs out
    for (i=0; i<dataset->dims; i++)
    {
        // initial coordinates
        Vec2 p;
        p.X = -2.5*font_size.X;
        p.Y = screen_distortion->scatter_Y_axes[i]; // - font_size.Y*1.1;

        for (int j=0; j<int(strlen(dataset->names[i])); j++)
        {
            Vec2 letter = canvas->GetDataFontSize(&dataset->names[i][j],1);
            p.Y -= 1.2*letter.Y;

            if (p.Y > screen_distortion->scatter_Y_axes[i+1]+letter.Y) break;

            canvas->DrawString(p.X,p.Y,&dataset->names[i][j],1);
        }
    } 
}

// Draw grid.
void CScatter::DrawScatterGridWithTwoAxes(grCanvas *canvas)
{
    int i;
    glLineWidth(3.);
    glShadeModel(GL_SMOOTH);
    canvas->SetXorMode(false);

    canvas->SetForeground(interface_color[GRID2]);
    for (i = 0;i < dataset->dims;i++)
    {        
        canvas->DrawLine(screen_distortion->scatter_X_axes[i], screen_distortion->scatter_Y_axes[i], 
                        screen_distortion->scatter_X_axes[i+1], screen_distortion->scatter_Y_axes[i] );
        canvas->DrawLine(screen_distortion->scatter_X_axes[i], screen_distortion->scatter_Y_axes[i+1], 
                        screen_distortion->scatter_X_axes[i+1], screen_distortion->scatter_Y_axes[i+1] );
    }

    canvas->SetForeground(interface_color[GRID3]);
    for (i = 0;i < dataset->dims;i++)
    {        
        canvas->DrawLine(screen_distortion->scatter_X_axes[i], screen_distortion->scatter_Y_axes[i], 
                        screen_distortion->scatter_X_axes[i], screen_distortion->scatter_Y_axes[i+1] );
        canvas->DrawLine(screen_distortion->scatter_X_axes[i+1], screen_distortion->scatter_Y_axes[i], 
                        screen_distortion->scatter_X_axes[i+1], screen_distortion->scatter_Y_axes[i+1] );
    }

    glLineWidth(1.);
    canvas->SetForeground(interface_color[GRID1]);
    for (i = 0;i < dataset->dims;i++)
        for (int j = 0;j < dataset->dims;j++)
            canvas->DrawRectangle2(screen_distortion->scatter_X_axes[i], screen_distortion->scatter_X_axes[i+1], 
                                   screen_distortion->scatter_Y_axes[j], screen_distortion->scatter_Y_axes[j+1] );
    
/* for fisheye view
	int i;
	for ( i = 0; i <= dataset->dims; i++ )
		canvas->DrawLineTemp(screen_distortion->scatter_X_axes[i], screen_distortion->scatter_Y_axes[0],
								screen_distortion->scatter_X_axes[i], screen_distortion->scatter_Y_axes[dataset->dims]);
	for ( i = 0; i <= dataset->dims; i++ )
		canvas->DrawLineTemp(screen_distortion->scatter_X_axes[0], screen_distortion->scatter_Y_axes[i],
								screen_distortion->scatter_X_axes[dataset->dims], screen_distortion->scatter_Y_axes[i]);
*/

//jing draw the labels of the plots
    // do labels
    canvas->SetForeground(interface_color[TEXT]);

    Vec2 font_size = canvas->GetDataFontSize("W");

    // draw horizontal labels
    // add letters one at a time until space runs out
    for (i=0; i<dataset->dims; i++)
    {
        double y = .8*font_size.Y;
        
        char name[50], name_a[30];
        strcpy(name, dataset->names[i]);
        sprintf(name_a, "(%1d)", dim_reducer->GetEntries(i));
        strcat(name, name_a);

        canvas->DrawConfinedString(screen_distortion->scatter_X_axes[i],y,name,
								   screen_distortion->scatter_X_interval[i]-font_size.X*3);
    }

    // draw vertical labels
    // add letters one at a time until space runs out
    for (i=0; i<dataset->dims; i++)
    {
        // initial coordinates
        Vec2 p;
        p.X = -2.5*font_size.X;
        p.Y = screen_distortion->scatter_Y_axes[i]; // - font_size.Y*1.1;

        char name[50], name_a[30];
        strcpy(name, dataset->names[i]);
        sprintf(name_a, "(%1d)", dim_reducer->GetEntries(i));
        strcat(name, name_a);

        for (int j=0; j<int(strlen(name)); j++)
        {
            Vec2 letter = canvas->GetDataFontSize(&dataset->names[i][j],1);
            p.Y -= 1.2*letter.Y;

            if (p.Y > screen_distortion->scatter_Y_axes[i+1]+letter.Y) break;

            canvas->DrawString(p.X,p.Y,&name[j],1);
        }
    }
}


// Draw grid.
void CScatter::DrawScatterGridWideAxes(grCanvas *canvas)
{
    int i;
    glShadeModel(GL_SMOOTH);
    canvas->SetXorMode(false);

    canvas->SetForeground(interface_color[GRID1]);
    for (i = 0;i < dataset->dims;i++)
    {        
        if ( ! dim_reducer->IsLeafDim(i) )
        {
            double dim_disagreement = dim_reducer->GetDimDisagreement(i);
            glLineWidth((float)(1.+ dim_disagreement * 10.));

            for ( int j = 0; j <= dataset->dims; j++ )
            {
                canvas->DrawLine(screen_distortion->scatter_X_axes[i], screen_distortion->scatter_Y_axes[j], 
                        screen_distortion->scatter_X_axes[i+1], screen_distortion->scatter_Y_axes[j] );
                canvas->DrawLine(screen_distortion->scatter_X_axes[j], screen_distortion->scatter_Y_axes[i], 
                        screen_distortion->scatter_X_axes[j], screen_distortion->scatter_Y_axes[i+1]);
            }
        }
    }

    glLineWidth(1.);
    canvas->SetForeground(interface_color[GRID1]);
    for (i = 0;i < dataset->dims;i++)
        for (int j = 0;j < dataset->dims;j++)
            canvas->DrawRectangle2(screen_distortion->scatter_X_axes[i], screen_distortion->scatter_X_axes[i+1], 
                                   screen_distortion->scatter_Y_axes[j], screen_distortion->scatter_Y_axes[j+1] );
    
/* for fisheye view
	int i;
	for ( i = 0; i <= dataset->dims; i++ )
		canvas->DrawLineTemp(screen_distortion->scatter_X_axes[i], screen_distortion->scatter_Y_axes[0],
								screen_distortion->scatter_X_axes[i], screen_distortion->scatter_Y_axes[dataset->dims]);
	for ( i = 0; i <= dataset->dims; i++ )
		canvas->DrawLineTemp(screen_distortion->scatter_X_axes[0], screen_distortion->scatter_Y_axes[i],
								screen_distortion->scatter_X_axes[dataset->dims], screen_distortion->scatter_Y_axes[i]);
*/

//jing draw the labels of the plots
    // do labels
    canvas->SetForeground(interface_color[TEXT]);

    Vec2 font_size = canvas->GetDataFontSize("W");

    // draw horizontal labels
    // add letters one at a time until space runs out
    for (i=0; i<dataset->dims; i++)
    {
        double y = .8*font_size.Y;
        
        char name[50], name_a[30];
        strcpy(name, dataset->names[i]);
        sprintf(name_a, "(%1d)", dim_reducer->GetEntries(i));
        strcat(name, name_a);

        canvas->DrawConfinedString(screen_distortion->scatter_X_axes[i],y,name,
								   screen_distortion->scatter_X_interval[i]-font_size.X*3);
    }

    // draw vertical labels
    // add letters one at a time until space runs out
    for (i=0; i<dataset->dims; i++)
    {
        // initial coordinates
        Vec2 p;
        p.X = -2.5*font_size.X;
        p.Y = screen_distortion->scatter_Y_axes[i]; // - font_size.Y*1.1;

        char name[50], name_a[30];
        strcpy(name, dataset->names[i]);
        sprintf(name_a, "(%1d)", dim_reducer->GetEntries(i));
        strcat(name, name_a);

        for (int j=0; j<int(strlen(name)); j++)
        {
            Vec2 letter = canvas->GetDataFontSize(&dataset->names[i][j],1);
            p.Y -= 1.2*letter.Y;

            if (p.Y > screen_distortion->scatter_Y_axes[i+1]+letter.Y) break;

            canvas->DrawString(p.X,p.Y,&name[j],1);
        }
    }
}

void CScatter::InputScatterFindPlot(grCanvas *canvas, int sx, int sy, int &X_dim, int &Y_dim)
{
    Vec2 p = canvas->MapScreenToData( Vec2(sx,sy) );
    int i = -1, j = -1;
    while ( i < dataset->dims && p.X > screen_distortion->scatter_X_axes[i+1] )
        i++;
    while ( j < dataset->dims && p.Y > screen_distortion->scatter_Y_axes[j+1] )
        j++;

    X_dim = i;
    Y_dim = j;
    return;
}


void CScatter::InputScatterScalePlotSize(grCanvas *canvas, int X_dim, int Y_dim, double delta)
{
    if ( X_dim < 0 || X_dim >= dataset->dims )
        return;
    if ( Y_dim < 0 || Y_dim >= dataset->dims )
        return;

    screen_distortion->ScatterScalePlot(X_dim, Y_dim, delta);
    return;
}


void CScatter::ScatterCaption(grCanvas *canvas, int x, int y)
{
    Vec2 p = canvas->MapScreenToData( Vec2(x,y) );

/*    double fx = p.X * dataset->dims;
    double fy = p.Y * dataset->dims;
    if (fx<0 || fy<0) return;

    int dim_x = int(fx);
    int dim_y = int(fy);
    dim_x = CLAMP(dim_x,0,dataset->dims-1);
    dim_y = CLAMP(dim_y,0,dataset->dims-1);
*/
    int dim_x, dim_y;
    InputScatterFindPlot(canvas, x, y, dim_x, dim_y);
    dim_x = CLAMP(dim_x,0,dataset->dims-1);
    dim_y = CLAMP(dim_y,0,dataset->dims-1);

    double datax = XINVMAP(dim_x,p.X);
    double datay = YINVMAP(dim_y,p.Y);

    char caption[100];
    sprintf(caption,"%s=",dataset->names[dim_x]);

    if (dataset->nominal_fields[dim_x] != 0) {
//        int value = (int) rint(datax);
//jing 
		int value = (int)(datax+0.5);
//jing
        const char *string = dataset->nominal_fields[dim_x]->MapValueToString(value);
        strcat(caption,string);
        strcat(caption," ");
    } else {
        sprintf(caption, "%s%.2lf ", caption, datax);
    }

    strcat(caption,", ");
    strcat(caption,dataset->names[dim_y]);
    strcat(caption,"=");

    if (dataset->nominal_fields[dim_y] != 0) {
 //       int value = (int) rint(datay);
//jing
		int value = (int)(datay+0.5);
//jing

        const char *string = dataset->nominal_fields[dim_y]->MapValueToString(value);
        strcat(caption,string);
        strcat(caption," ");
    } else {
        sprintf(caption, "%s%.2lf ", caption, datay);
    }

    appShowCanvasMessage(Togl_Interp(canvas->GetWidget()),caption, canvas->name);
}



double CScatter::XMAP(int DIM, double VAL) 
{
    return screen_distortion->scatter_X_axes[DIM] + 
           ( VAL - dataset->dim_min[DIM] ) * ( screen_distortion->scatter_X_axes[DIM+1] - screen_distortion->scatter_X_axes[DIM] ) 
             / (dataset->dim_max[DIM] - dataset->dim_min[DIM] );
}


double CScatter::YMAP(int DIM, double VAL)
{
    return screen_distortion->scatter_Y_axes[DIM] + 
           ( (dataset->dim_max[DIM] - VAL) * (screen_distortion->scatter_Y_axes[DIM+1] - screen_distortion->scatter_Y_axes[DIM] ) 
             / (dataset->dim_max[DIM] - dataset->dim_min[DIM]) );
}


//reverse of xmap. map screen back to data
double CScatter::XINVMAP(int DIM, double VAL)
{
    return (VAL-screen_distortion->scatter_X_axes[DIM]) * (dataset->dim_max[DIM] - dataset->dim_min[DIM]) 
            / (screen_distortion->scatter_X_axes[DIM+1] - screen_distortion->scatter_X_axes[DIM] ) 
           + dataset->dim_min[DIM];
}


double CScatter::YINVMAP(int DIM, double VAL)
{
    return dataset->dim_max[DIM] - 
           ( VAL - screen_distortion->scatter_Y_axes[DIM] ) * ( dataset->dim_max[DIM] - dataset->dim_min[DIM] ) 
             / ( screen_distortion->scatter_Y_axes[DIM+1] - screen_distortion->scatter_Y_axes[DIM] );
}

